<?php

##########################################################################################
# In order to be able to use this script you need to join the merchant program depending on the country where your store is selling the products
#
# AUSTRALIA - http://shopmania.com.au/ (only supporting AUD, NZD datafeeds)
# ARGENTINA - http://www.shopmania.com.ar/ (only supporting ARS, EUR, USD)       *NEW
# BRASIL - http://www.shopmania.com.br/ (only supporting BRL, USD) 
# BULGARY - http://www.shopmania.bg/ (only supporting BGN, EUR, USD)
# CZECH REPUBLIC - http://www.shop-mania.cz/ (only supporting CZK, EUR, USD)		*NEW
# CHILE - http://www.shopmania.cl/ (only supporting CLP, USD, EUR)       *NEW
# CHINA - http://www.shopmania.cn/ (only supporting CNY, USD)       
# DEUTSCHLAND - http://www.shopmania.de/ (only supporting EUR, USD) 
# FRANCE - http://www.shopmania.fr/ (only supporting EUR, USD datafeeds)
# HUNGARY - http://www.shopmania.hu/ (only supporting HUF, EUR, USD datafeeds)
# INDIA - http://www.shopmania.in/ (only supporting INR, USD datafeeds)
# IRELAND - http://www.shopmania.ie/ (only supporting EUR, GBP datafeeds)
# ITALY - http://www.shopmania.it/ (only supporting EUR, USD datafeeds)
# JAPAN - http://www.shopmania.jp/  (only supporting JPY, USD datafeeds)       
# MEXICO - http://www.shopmania.com.mx/ (only supporting MXN (Mexican peso), USD, EUR datafeeds)
# NETHERLANDS - http://www.shopmania.nl/ (only supporting EUR datafeeds)		*NEW
# POLSKA - http://www.shopmania.pl/ (only supporting PLN, EUR, USD) 
# PORTUGAL - http://www.shopmania.pt/ (only supporting EUR, USD) 
# ROMANIA - http://www.shopmania.ro/ (only supporting RON, EUR, USD datafeeds)
# RUSSIA - http://www.shopmania.ru/ (only supporting RUB, EUR, USD)       
# SERBIA - http://www.shopmania.rs/ (only supporting RSD, EUR)		*NEW	
# SLOVAKIA - http://www.shop-mania.sk/ (only supporting EUR, USD)
# SOUTH AFRICA - http://www.shopmania.co.za/ (only supporting ZAR, USD, EUR)       *NEW
# SPAIN - http://www.shopmania.es/ (only supporting EUR datafeeds) 
# SWEDEN - http://www.shopmania.se/ (only supporting SEK, EUR, USD datafeeds)		*NEW
# TURKEY - http://www.shopmania.com.tr/ (only supporting TRY, EUR, USD)
# US - http://www.shopmania.com/ (only supporting USD, CAD datafeeds)
# UK - http://www.shopmania.co.uk/ (only supporting GBP, EUR, USD datafeeds)
#
# Once you join the program and your application is approved you need to place the file on your server and set up the path to the file on the Merchant Interface
# Files will be  retrieved daily from your server having the products listed automatically on ShopMania
# 
# 
# Options
# @url_param taxes=on (on,off) 
# @url_param storetaxes=on (on,off) 
# @url_param discount=on (on,off) 
# @url_param special=on (on,off) 
# @url_param add_vat=off (on,off) 
# @url_param shipping=off (on,off) 
# @url_param add_tagging=on (on,off) 
# @url_param tagging_params=&utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link (TAGGING_PARAMS) 
# @url_param description=on (on,off) 
# @url_param image=on (on,off) 
# @url_param specialprice=on (on,off) 
# @url_param sef=off (on,off) 
# @url_param on_stock=off (on,off) 
# @url_param forcepath=off (on,off) 
# @url_param forcefolder= (FORCEFOLDER) 
# @url_param language= (LANGUAGE_CODE) 
# @url_param language_id= (LANGUAGE_ID) 
# @url_param currency= (CURRENCY_CODE) 
#
# 
##########################################################################################

// Current datafeed script version
$script_version = "1.04";

// Print current Script version
if (@$_GET['get'] == "version") {
	echo "<b>Datafeed INDIGO Shop</b> <br />";
	echo "version <b>" . $script_version . "</b><br />";
	exit;
}

session_start();

// Se no time limit only if php is not in Safe Mode
if (!ini_get("safe_mode")) {
	set_time_limit(0);
}
ignore_user_abort();
error_reporting(E_ALL^E_NOTICE);

$_SVR = array();

# If you use a default configuration you need to do place this file in your /catalog/ directory. 
# Otherwise if you place this file in another directory please modify the line below with the path to the catalog directory. 

##### Include configuration files ################################################

$site_base_path = "./";

if(!file_exists($site_base_path . "includes/config.inc.php")) {
	exit('<HTML><HEAD><TITLE>404 Not Found</TITLE></HEAD><BODY><H1>Not Found</H1>Please ensure that datafeed_shopmania_indigocart.php is in the root directory, or make sure the path to the root directory is defined corectly above</BODY></HTML>');
}
else {
	require_once($site_base_path . "includes/config.inc.php");
}

require_once(LOCAL_PATH . '/includes/globals_functions.inc.php');
require_once(LOCAL_PATH . '/includes/classes/db.inc.php');

$DB = new db();

####################################################################

# Once all is set up you need to check the result and make sure the output is correct
# Point the browser to http://www.example.com/path_to_datafeed/shopmania_datafeed.php and look into the source code of the out put
# What you need to see is something like this
# Category | Manufacturer | Part Number | Merchant Code | Product Name | Product Description | Product URL | Product Image URL | Product Price | Currency 

##### Avoid any modifications below this line #####

// Datafeed specific settings
$datafeed_separator = "|"; // Possible options are \t or |

##### Extract params from url ################################################

$apply_taxes = (@$_GET['taxes'] == "off") ? "off" : "on";
$apply_storetaxes = (@$_GET['storetaxes'] == "off") ? "off" : "on";
$apply_discount = (@$_GET['discount'] == "off") ? "off" : "on";
$add_vat = (@$_GET['add_vat'] == "on") ? "on" : "off";
$vat_value = (@$_GET['vat_value'] > 0) ? ((100 + $_GET['vat_value']) / 100) : 1.24; // default value
$add_shipping = (@$_GET['shipping'] == "on") ? "on" : "off";
$add_tagging = (@$_GET['add_tagging'] == "off") ? "off" : "on";
$tagging_params = (@$_GET['tagging_params'] != "") ? urldecode($_GET['tagging_params']) : "utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link";
$show_description = (@$_GET['description'] == "off") ? "off" : "on";
$show_image = (@$_GET['image'] == "off") ? "off" : "on";
$show_specialprice = (@$_GET['specialprice'] == "off") ? "off" : "on";
$sef = (@$_GET['sef'] == "on") ? "on" : "off";
$on_stock_only = (@$_GET['on_stock_only'] == "on") ? "on" : "off";
$language_code = (@$_GET['language'] != "") ? $_GET['language'] : "";
$language_id = (@$_GET['language_id'] != "") ? $_GET['language_id'] : "";
$currency = (@$_GET['currency'] != "") ? $_GET['currency'] : "";
$force_path = (@$_GET['forcepath'] == "on") ? "on" : "off";
$round_price = (@$_GET['round_price'] == "off") ? "off" : "on";

####################################################################
 
// Print URL options
if (@$_GET['get'] == "options") {
	$script_basepath = "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'];
	
	echo "<b>Datafeed INDIGO Shop</b> <br />";
	echo "version <b>" . $script_version . "</b><br /><br /><br />";
		
	echo "<b>Taxes options</b> - possible values on, off default value on<br />";
	echo "taxes=on (on,off) <a href=\"" . $script_basepath . "?taxes=off" . "\" >" . $script_basepath . "?taxes=off" . "</a><br /><br />";
	
	//echo "<b>Store taxes options</b> - possible values on, off default value on<br />";
	//echo "storetaxes = on (on,off) <a href=\"" . $script_basepath . "?storetaxes=off" . "\" >" . $script_basepath . "?storetaxes=off" . "</a><br /><br />";
	
	echo "<b>Discount options</b> - possible values on, off default value on<br />";
	echo "discount=on (on,off) <a href=\"" . $script_basepath . "?discount=off" . "\" >" . $script_basepath . "?discount=off" . "</a><br /><br />";
	
	//echo "<b>Special price options</b> - possible values on, off default value on<br />";
	//echo "special=on (on,off) <a href=\"" . $script_basepath . "?special=off" . "\" >" . $script_basepath . "?special=off" . "</a><br /><br />";
	
	echo "<b>Add VAT to prices</b> - possible values on, off default value off<br />";
	echo "add_vat=off (on,off) <a href=\"" . $script_basepath . "?add_vat=on" . "\" >" . $script_basepath . "?add_vat=on" . "</a><br /><br />";
	
	echo "<b>VAT value</b> - possible values percent value default value 24  - interger or float number ex 19 or 19.5<br />";
	echo "vat_value=24 (VAT_VALUE) <a href=\"" . $script_basepath . "?add_vat=on&vat_value=19" . "\" >" . $script_basepath . "?add_vat=on&vat_value=19" . "</a><br /><br />";
	
	echo "<b>Round prices</b> - possible values on, off<br />";
	echo "round_price=off (on,off) <a href=\"" . $script_basepath . "?round_price=off" . "\" >" . $script_basepath . "?round_price=off" . "</a><br /><br />";
	
	//echo "<b>Add shipping to datafeed</b> - possible values on, off default value off<br />";
	//echo "shipping=off (on,off) <a href=\"" . $script_basepath . "?shipping=off" . "\" >" . $script_basepath . "?shipping=off" . "</a><br /><br />";
	
	echo "<b>Add GA Tagging to product URL</b> - possible values on, off default value on<br />";
	echo "add_tagging=on (on,off) <a href=\"" . $script_basepath . "?add_tagging=off" . "\" >" . $script_basepath . "?add_tagging=off" . "</a><br /><br />";
		
	echo "<b>Add custom Tagging to product URL</b> - possible values url_encode(TAGGING_PARAMS) default value tagging_params=utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link<br />";
	echo "tagging_params=utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link (TAGGING_PARAMS) <a href=\"" . $script_basepath . "?tagging_params=from%3Dshopmania" . "\" >" . $script_basepath . "?tagging_params=from%3Dshopmania" . "</a><br /><br />";
	
	//echo "<b>Display Description options</b> - possible values on, off<br />";
	//echo "description=on (on,off) <a href=\"" . $script_basepath . "?description=off" . "\" >" . $script_basepath . "?description=off" . "</a><br /><br />";

	//echo "<b>Display image options</b> - possible values on, off default value on<br />";
	//echo "image=on (on,off) <a href=\"" . $script_basepath . "?image=off" . "\" >" . $script_basepath . "?image=off" . "</a><br /><br />";
	
	//echo "<b>Special price options</b> - possible values on, off default value on<br />";
	//echo "specialprice=on (on,off) <a href=\"" . $script_basepath . "?specialprice=off" . "\" >" . $script_basepath . "?specialprice=off" . "</a><br /><br />";
	
	echo "<b>Show only on stock products</b> - possible values on, off default value on<br />";
	echo "on_stock_only=off (on,off) <a href=\"" . $script_basepath . "?on_stock_only=on" . "\" >" . $script_basepath . "?on_stock_only=on" . "</a><br /><br />";
		
	//echo "<b>Add basepath to product URL</b> - possible values on, off default value off<br />";
	//echo "forcepath=off (on,off) <a href=\"" . $script_basepath . "?forcepath=on" . "\" >" . $script_basepath . "?forcepath=on" . "</a><br /><br />";
		
	//echo "<b>Get prices in specified currency</b> - possible values USD,EUR etc. <br />";
	//echo "currency=DEFAULT_CURRENCY <a href=\"" . $script_basepath . "?currency=EUR" . "\" >" . $script_basepath . "?currency=EUR" . "</a><br /><br />";
	
	//echo "<b>Get texts in specified language code</b> - possible values en,ro etc. <br />";
	//echo "language=DEFAULT_LANGUAGE_CODE <a href=\"" . $script_basepath . "?language=en" . "\" >" . $script_basepath . "?language=en" . "</a><br /><br />";
	
	//echo "<b>Get texts in specified language id</b> - possible values 1,2 etc. <br />";
	//echo "language_id=DEFAULT_LANGUAGE_ID <a href=\"" . $script_basepath . "?language_id=1" . "\" >" . $script_basepath . "?language_id=1" . "</a><br /><br />";
		
	exit;
}

##### Extract options from database ################################################

$current_lang_code = $DB->fetch_value("SELECT acronym_lng FROM language_lng WHERE default_lng='1'");

// GT default lang id
$current_lang = $DB->fetch_value("SELECT id_lng FROM language_lng WHERE acronym_lng='" . addslashes($current_lang_code) . "'");
$current_lang = ($current_lang > 0) ? $current_lang : 1;

// Get default currency code
$currency_code = $DB->fetch_value("SELECT acronym_cur FROM currencies_cur WHERE default_cur='1'");

$sql_cat = sprintf("SELECT *
FROM categories_cat
LEFT JOIN categories2lang_c2l ON categories_cat.id_cat = categories2lang_c2l.idcat_c2l AND idlng_c2l='" . addslashes($current_lang) . "'");

$res_cat = $DB->query($sql_cat);
while($field = $DB->fetch_assoc($res_cat)){
	$CAT_ARR[$field['id_cat']] = $field; 
}

######################################################################


##### Extract products from database ###############################################

// Build on stock condition
$on_stock_cond = ($on_stock_only == "on") ? " AND products_prd.quantity_prd > 0 " : "";

// Query database for extracting data. It might be needed to left join the categories table for extracting the category name
$sql_prod = sprintf("SELECT categories_cat.id_cat AS cat_id, manufacturers_man.name_man AS prod_manufacturer, products_prd.id_prd AS prod_id, products2lang_r2l.name_r2l AS prod_name, products2lang_r2l.description_r2l AS prod_desc, products_prd.type_prd AS prod_image_ext, products_prd.price_prd AS prod_price, products_prd.promotional_price_prd AS prod_promotional_price, taxes_tax.value_tax AS tax_rate, products_prd.idtax_prd 
FROM products_prd
LEFT JOIN products2lang_r2l ON products_prd.id_prd = products2lang_r2l.idprd_r2l AND idlng_r2l=1
LEFT JOIN categories_cat ON products_prd.idcat_prd = categories_cat.id_cat
LEFT JOIN manufacturers_man ON products_prd.idman_prd = manufacturers_man.id_man
LEFT JOIN taxes_tax ON products_prd.idtax_prd = taxes_tax.id_tax
WHERE products_prd.active_prd = '1' 
" . $on_stock_cond . "
ORDER BY products_prd.id_prd ASC");

$res_prod = $DB->query($sql_prod);

###################################################################


##### Print product data ####################################################

$current_id = 0;

// There are no errors so we can continue
if (!mysql_error()) {
	while($field = $DB->fetch_assoc($res_prod)){
		
		// If we've sent this one, skip the rest - this is to ensure that we do not get duplicate products
		$prod_id = $field['prod_id'];
		
		if ($current_id == $prod_id) {
			continue;
		}
		else {
			$current_id = $prod_id;
		}
		
		// Clean product name (new lines)
		$field['prod_name'] = str_replace("\n", "", strip_tags($field['prod_name']));
		// Clean product description (Replace new line with <BR>). In order to make sure the code does not contains other HTML code it might be a good ideea to strip_tags()
		$field['prod_desc'] = smfeed_replace_not_in_tags("\n", "<BR />", $field['prod_desc']);
		$field['prod_desc'] = str_replace("\n", " ", $field['prod_desc']);
		$field['prod_desc'] = str_replace("\r", "", $field['prod_desc']);
				
		// Round prices
		if ($apply_discount == "on" && $field['prod_promotional_price'] > 0) {
			$field['prod_price'] = $field['prod_promotional_price'];
		}
				
		// Include tax - if this is not working corectly simply comment the following lines and you will have the prices without the tax included
		if ($apply_taxes == "on" && $field['tax_rate'] > 0 && $field['idtax_prd'] > 0) {
			$field['prod_price'] = $field['prod_price'] + ( ( $field['prod_price'] * $field['tax_rate'] ) / 100 );
		}
	
		// Add VAT to prices
		if ($add_vat == "on") {
			$field['prod_price'] = $field['prod_price'] * $vat_value;
		}
		
		// Round prices
		if ($round_price == "on") {
			$field['prod_price'] = round($field['prod_price']);
		}
		
		$cat_str_key = smfeed_build_str_key($CAT_ARR[$field['cat_id']]['name_c2l']);
		$prod_str_key = smfeed_build_str_key($field['prod_name']);
		
		$prod_url = smfeed_get_product_url($cat_str_key, $prod_str_key, $field['prod_id']);
		// Add GA Tagging parameters to url
		if ($add_tagging == "on") {
			$and_param = (preg_match("/\?/", $prod_url)) ? "&" : "?";
			$prod_url = $prod_url . $and_param . $tagging_params;
		}
		
		$prod_image = smfeed_get_product_image($field['prod_id'], $field['prod_image_ext']);		
		
		// Required fields are: category name, merchant product ID, product name, product URL, product price
		// For the product model you should only use the manufacturer code, ISBN code or UPC code - If you are not sure about a field please leave it empty
		
		// Strip html from category name
		$cat_name = smfeed_get_full_cat($field['cat_id'], $CAT_ARR);
		
		// Clean product names and descriptions (separators)
		if ($datafeed_separator == "\t") {
			$field['prod_name'] = str_replace("\t", " ", strip_tags($field['prod_name']));
			$field['prod_desc'] = str_replace("\t", " ", $field['prod_desc']);
			$cat_name = str_replace("\t", " ", $cat_name);
		}
		elseif ($datafeed_separator == "|") {
			$field['prod_name'] = str_replace("|", " ", strip_tags($field['prod_name']));
			$field['prod_desc'] = str_replace("|", " ", $field['prod_desc']);
			$cat_name = str_replace("|", " ", $cat_name);
		}
		else {
			print "Incorrect columns separator.";
			exit;			
		}
		
		
		// Output the datafeed content
		print  
		$cat_name . $datafeed_separator . 
		$field['prod_manufacturer'] . $datafeed_separator . 
		"" . $datafeed_separator . 
		$field['prod_id'] . $datafeed_separator . 
		$field['prod_name'] . $datafeed_separator . 
		$field['prod_desc'] . $datafeed_separator . 
		$prod_url . $datafeed_separator . 
		$prod_image . $datafeed_separator . 
		$field['prod_price'] . $datafeed_separator . 
		$currency_code . "\n";
	}

}
else {
	print "Query error: " . mysql_error();
}

###################################################################


##### Functions ########################################################

// Get categories fulll path
function smfeed_get_full_cat($cat_id, $CATEGORY_ARR) {

	$item_arr = $CATEGORY_ARR[$cat_id];
	$cat_name = $item_arr['name_c2l'];
	
	while (sizeof($CATEGORY_ARR[$item_arr['parent_id_cat']]) > 0 && is_array($CATEGORY_ARR[$item_arr['parent_id_cat']]) ) {
		
		$cat_name = $CATEGORY_ARR[$item_arr['parent_id_cat']]['name_c2l'] . " > " . $cat_name;		
		$item_arr = $CATEGORY_ARR[$item_arr['parent_id_cat']];
	}
	
	// Strip html from category name
	$cat_name = smfeed_html_to_text($cat_name);
	
	return $cat_name;
}

// Function to return the Product URL based on your product ID
function smfeed_get_product_url($cat_str_key, $prod_str_key, $prod_id){	
	return URL_PATH . "/" . $cat_str_key . "/" . $prod_str_key . "-" . $prod_id;
}

// Function to return the Product Image based on your product image or optionally Product ID
function smfeed_get_product_image($prod_id, $img_ext){	
	return URL_PATH . PRODUCTS_PATH . $prod_id . "." . $img_ext;	
}

function smfeed_html_to_text($string){

	$search = array (
		"'<script[^>]*?>.*?</script>'si",  // Strip out javascript
		"'<[\/\!]*?[^<>]*?>'si",  // Strip out html tags
		"'([\r\n])[\s]+'",  // Strip out white space
		"'&(quot|#34);'i",  // Replace html entities
		"'&(amp|#38);'i",
		"'&(lt|#60);'i",
		"'&(gt|#62);'i",
		"'&(nbsp|#160);'i",
		"'&(iexcl|#161);'i",
		"'&(cent|#162);'i",
		"'&(pound|#163);'i",
		"'&(copy|#169);'i",
		"'&(reg|#174);'i",
		"'&#8482;'i",
		"'&#149;'i",
		"'&#151;'i"
		);  // evaluate as php
	
	$replace = array (
		" ",
		" ",
		"\\1",
		"\"",
		"&",
		"<",
		">",
		" ",
		"&iexcl;",
		"&cent;",
		"&pound;",
		"&copy;",
		"&reg;",
		"<sup><small>TM</small></sup>",
		"&bull;",
		"-",
		);
	
	$text = preg_replace ($search, $replace, $string);
	return $text;
	
}


function smfeed_build_str_key($text){
	
	$text = str_replace(" ", "-", trim(smfeed_string_clean_search($text)));
	$text = rawurlencode(strtolower($text));
	
	$text = strtolower(smfeed_clean_accents($text));
	
	$text = rawurldecode($text);
	
	return $text;
}

function smfeed_clean_accents($text){

	$search = array (
		
		"'%C4%99'", #e
		"'%C3%A8'", #e
		"'%C3%A9'", #e
		"'%C3%AA'", #e
		"'%C3%AB'", #e
		"'%C3%89'", #e
		"'%C3%88'", #E
		"'%C3%8A'", #E
		
		"'%C4%85'", #a
		"'%C3%A3'", #a
		"'%C3%A0'", #a
		"'%C3%A4'", #a
		"'%C3%A2'", #a	
		"'%C3%A1'", #a
		"'%C3%A5'", #a
		"'%C3%81'", #A
		"'%C3%82'", #A
		"'%C3%84'", #A
		"'%C3%85'", #A
		"'%C3%80'", #A
		
		"'%C4%87'", #c
		"'%C3%A7'", #c
		"'%C3%87'", #C
		
		"'%C5%9B'", #s
		"'%C5%A1'", #s
		"'%C5%A0'", #S
		"'%C5%9A'", #S
		
		"'%C3%B0'", #d
		"'%C3%B1'", #n
		"'%C3%BD'", #y
		"'%C4%9F'", #g
		
		"'%C4%B1'", #i
		"'%C3%AE'", #i
		"'%C3%AD'", #i
		"'%C3%AF'", #i
		"'%C3%AC'", #i
		"'%C3%8D'", #I
		"'%C3%8E'", #I
		"'%C4%B0'", #I
		
		"'%C5%82'", #l
		
		"'%C5%84'", #n
		
		"'%C3%BA'", #u
		"'%C3%BB'", #u
		"'%C3%B9'", #u
		"'%C3%BC'", #u
		"'%C5%B1'", #u
		
		"'%C3%9C'", #U
		
		"'%C3%B4'", #o
		"'%C3%B3'", #o
		"'%C3%91'", #o
		"'%C3%B6'", #o
		"'%C5%91'", #o
		"'%C3%B2'", #o
		"'%C3%B5'", #o
		"'%C3%93'", #O
		"'%C3%96'", #O
		
		"'%C3%9F'", #ss
		"'%C5%BC'", #z
		"'%C5%BA'", #z
		"'%C5%BB'", #Z
		
		"'%C3%A6'", #ae
		"'%C3%B8'", #oe
		
		"'%C2%AE'",
		"'%C2%B4'",
		"'%E2%84%A2'",
		
	);
	
	$replace = array (
		
		"e",
		"e",
		"e",
		"e",
		"e",
		"e",
		"E",
		"E",
		
		"a",
		"a",
		"a",
		"a",
		"a",
		"a",
		"a",
		"A",
		"A",
		"A",
		"A",
		"A",
		
		"c",
		"c",
		"C",
		
		"s",
		"s",
		"S",
		"S",
		
		"d",
		"n",
		"y",
		"g",
		
		"i",
		"i",
		"i",
		"i",
		"i",
		"I",
		"I",
		"I",
		
		"l",
		
		"n",
		
		"u",
		"u",
		"u",
		"u",
		"u",
		
		"U",
		
		"o",
		"o",
		"o",
		"o",
		"o",
		"o",
		"o",
		"O",
		"O",
		
		"ss",
		"z",
		"z",
		"Z",
		
		"ae",
		"oe",
		
		"",
		"",
		"",
		
	);
	
	$text = preg_replace($search, $replace, $text);
	
	return $text;

}

// CLEANS STRINGS
function smfeed_string_clean_search($string){
	
	$trans = get_html_translation_table(HTML_ENTITIES);
	$trans = array_flip ($trans);
	$string = strtr($string, $trans);
	
	$search = array (
		"'/'",
		"','",
		"'&quot;'",
		"'&lt;'",
		"'&gt;'",
		"'%&pound;'",
		"'%&euro;'",
		"'-'",
		"'~'",
		"'!'",
		"'\?'",
		"'@'",
		"'#'",
		"'\\$'",
		"'%'",
		"'\^'",
		"'&'",
		"'\*'",
		"'\('",
		"'\)'",
		"'_'",
		"'='",
		"'\''",
		"'\['",
		"'\]'",
		"'{'",
		"'}'",
		"'\|'",
		"'\"'",
		"':'",
		"';'",
		"'\\\'",
		"'>'",
		"'<'",		
		"'[\r]+'",
		"'[\n]+'",
		"'[\t]+'",
		"'[\s]+'",
		//"'\.'",
		//"'\+'",
		//"'/'",
	);
	
	$replace = array (
		" ",
		"",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		//" ",
		//" ",
		//" ",
	);
	
	$string = preg_replace($search, $replace, $string);
	
	return $string;
	
}

function smfeed_replace_not_in_tags($find_str, $replace_str, $string) {
	
	$find = array($find_str);
	$replace = array($replace_str);	
	preg_match_all('#[^>]+(?=<)|[^>]+$#', $string, $matches, PREG_SET_ORDER);	
	foreach ($matches as $val) {	
		if (trim($val[0]) != "") {
			$string = str_replace($val[0], str_replace($find, $replace, $val[0]), $string);
		}
	}	
	return $string;
}

###################################################################

session_destroy();

exit;

?>